Cf. http://blog.blackdown.de/2007/11/15/compiz-patches/

* Metacity-like raise/lower on window decorations
* Fix copy/paste errors in decoration calculations

Signed-off-by: Juergen Kreileder <jk@blackdown.de>

diff -ur /home/jk/compiz-0.6.2+git20071101.orig/gtk/window-decorator/gtk-window-decorator.c compiz-0.6.2+git20071101/gtk/window-decorator/gtk-window-decorator.c
--- /home/jk/compiz-0.6.2+git20071101.orig/gtk/window-decorator/gtk-window-decorator.c	2007-11-14 19:37:01.000000000 +0100
+++ compiz-0.6.2+git20071101/gtk/window-decorator/gtk-window-decorator.c	2007-11-14 19:37:42.000000000 +0100
@@ -4424,32 +4424,48 @@
 top_left_event (WnckWindow *win,
 		XEvent     *xevent)
 {
-    if (xevent->xbutton.button == 1)
+    if (xevent->xbutton.button == 1) {
+	restack_window (win, Above);
 	move_resize_window (win, WM_MOVERESIZE_SIZE_TOPLEFT, xevent);
+    } else if (xevent->xbutton.button == 2) {
+	restack_window (win, Below);
+    }
 }
 
 static void
 top_event (WnckWindow *win,
 	   XEvent     *xevent)
 {
-    if (xevent->xbutton.button == 1)
+    if (xevent->xbutton.button == 1) {
+	restack_window (win, Above);
 	move_resize_window (win, WM_MOVERESIZE_SIZE_TOP, xevent);
+    } else if (xevent->xbutton.button == 2) {
+	restack_window (win, Below);
+    }
 }
 
 static void
 top_right_event (WnckWindow *win,
 		 XEvent     *xevent)
 {
-    if (xevent->xbutton.button == 1)
+    if (xevent->xbutton.button == 1) {
+	restack_window (win, Above);
 	move_resize_window (win, WM_MOVERESIZE_SIZE_TOPRIGHT, xevent);
+    } else if (xevent->xbutton.button == 2) {
+	restack_window (win, Below);
+    }
 }
 
 static void
 left_event (WnckWindow *win,
 	    XEvent     *xevent)
 {
-    if (xevent->xbutton.button == 1)
+    if (xevent->xbutton.button == 1) {
+	restack_window (win, Above);
 	move_resize_window (win, WM_MOVERESIZE_SIZE_LEFT, xevent);
+    } else if (xevent->xbutton.button == 2) {
+	restack_window (win, Below);
+    }
 }
 
 static void
@@ -4833,32 +4849,47 @@
 right_event (WnckWindow *win,
 	     XEvent     *xevent)
 {
-    if (xevent->xbutton.button == 1)
+    if (xevent->xbutton.button == 1) {
+	restack_window (win, Above);
 	move_resize_window (win, WM_MOVERESIZE_SIZE_RIGHT, xevent);
+    } else if (xevent->xbutton.button == 2) {
+	restack_window (win, Below);
+    }
 }
 
 static void
 bottom_left_event (WnckWindow *win,
 		   XEvent     *xevent)
 {
-    if (xevent->xbutton.button == 1)
+    if (xevent->xbutton.button == 1) {
 	move_resize_window (win, WM_MOVERESIZE_SIZE_BOTTOMLEFT, xevent);
+    } else if (xevent->xbutton.button == 2) {
+	restack_window (win, Below);
+    }
 }
 
 static void
 bottom_event (WnckWindow *win,
 	      XEvent     *xevent)
 {
-    if (xevent->xbutton.button == 1)
+    if (xevent->xbutton.button == 1) {
+	restack_window (win, Above);
 	move_resize_window (win, WM_MOVERESIZE_SIZE_BOTTOM, xevent);
+    } else if (xevent->xbutton.button == 2) {
+	restack_window (win, Below);
+    }
 }
 
 static void
 bottom_right_event (WnckWindow *win,
 		    XEvent     *xevent)
 {
-    if (xevent->xbutton.button == 1)
+    if (xevent->xbutton.button == 1) {
+	restack_window (win, Above);
 	move_resize_window (win, WM_MOVERESIZE_SIZE_BOTTOMRIGHT, xevent);
+    } else if (xevent->xbutton.button == 2) {
+	restack_window (win, Below);
+    }
 }
 
 static void
@@ -5603,7 +5634,6 @@
 					 _win_extents.top + titlebar_height,
 					 _win_extents.bottom,
 					 _win_extents.left -
-					 _win_extents.left -
 					 TRANSLUCENT_CORNER_SIZE,
 					 _win_extents.right -
 					 TRANSLUCENT_CORNER_SIZE,
@@ -5630,7 +5660,6 @@
 			     _max_win_extents.right,
 			     _max_win_extents.top + max_titlebar_height,
 			     _max_win_extents.bottom,
-			     _max_win_extents.left -
 			     _max_win_extents.left - TRANSLUCENT_CORNER_SIZE,
 			     _max_win_extents.right - TRANSLUCENT_CORNER_SIZE,
 			     _max_win_extents.top + max_titlebar_height -
=
